/* Source file generated by Timbre */

#include "botforth.h"  /* interface to VFM */
#include "timbre.h" /* headers */ 
/* Timbre  Rob Chapman Dec 17, 1991 */
#include "extkern.h" /* ticks from kernel */
#include "extlib.h"  /* ticks from library */
#include "extii.h"  /* inner interpreters */
/* ==== Version ==== */

void TIMBRE_VERSION()  /* -- */
{
	*(char**)--sp="\013Timbre V.4 ";
	COUNT();
	TYPE();
}/* derived from Timbre V.3 */
/* ==== Define a rule set ==== */

void RULE_SET()  /* -- */
{
	DICTIONARY();
	CONSTANT();
}
/* ==== Word dictionary for rules ==== */
struct
{
	Cell name1;
}rule_words_={0,};

void rule_words()  /* -- a */  /* all words which appear in all rules */
{
	*--sp=(Cell)&rule_words_;
}


void _default()  /* -- s */
{
	*(char**)--sp="\003{ }";
}

void IN_RULES_QUERY()  /* s -- s' \ f */
{
	--sp,sp[0]=sp[1];	/* DUP */
	rule_words();
	sp[0]=*(Cell *)sp[0];	/* @ */
	FIND();
	if(sp[0])
	{	/* DUP IF */
		sp[1]=sp[0],sp++;	/* NIP */
		*--sp=-1;	/* YES */
	}
}

void GET_WORD()  /* -- name */
{
	BL();
	WORD();
	HERE();
	IN_RULES_QUERY();
	if(*sp++)	/* IF */
	{
		return;	/* EXIT */
	}
	--sp,sp[0]=*(Byte*)sp[1];	/* DUP C@ */
	sp[0]+=1;	/* + */
	ALLOCATE();
	--sp,sp[0]=sp[1],sp[1]=sp[2],sp[2]=sp[0];	/* TUCK */
	--sp,sp[0]=*(Byte*)sp[2];	/* OVER C@ */
	sp[0]+=1;	/* + */
	LESS_THAN_CMOVE();
	--sp,sp[0]=sp[1];	/* DUP */
	rule_words();
	sp[0]=*(Cell *)sp[0];	/* @ */
	INSERT();
}
/* ==== Rule set stack ==== */
struct
{
	Cell *i;
	Cell *r;
	Cell *e;
	Cell q[17];
}ruleq_={&ruleq_.q[16],&ruleq_.q[16],&ruleq_.q[16]};

void ruleq() /* -- q */  /* stack of rule sets for input pattern matching */
{
	*--sp=(Cell)&ruleq_;
}

struct
{
	Cell *i;
	Cell *r;
	Cell *e;
	Cell q[17];
}dictq_={&dictq_.q[16],&dictq_.q[16],&dictq_.q[16]};

void dictq()  /* -- q */  /* stack of check rule sets */
{
	*--sp=(Cell)&dictq_;
}

struct
{
	Cell name5;
}activity_={0,};

void activity()  /* -- a */  /* flag: an activity is being defined for a rule */
{
	*--sp=(Cell)&activity_;
}


void RULES_FROM()  /* -- rule-set */
{
	ruleq();
	PULL();
}

void TO_RULES()  /* rule-set -- */
{
	ruleq();
	STUFF();
}

void RULE_SETS_QUERY()  /* -- n */
{
	ruleq();
	Q_QUERY();
}

void NEXT_RULE_SET()  /* -- */
{
	RULES_FROM();
	dictq();
	PUSH();
}

void RESET_RULES()  /* -- */
{
	dictq();
	Q_QUERY();
	for(*--rp=*sp++;*rp;(*rp)--)	/* FOR */
	{
		dictq();
		POP();
		TO_RULES();
	}	/* NEXT */
	rp++;
}

void RULES()  /* ruleset -- */
{
	rule_words();
	sp[0]=*(Cell *)sp[0];	/* @ */
	if(!*sp++)
	{	/* 0= IF */
		DICTIONARY();
		rule_words();
		*(Cell *)sp[0]=sp[1],sp+=2;	/* ! */
	}
	*--sp=0;	/* NO */
	activity();
	*(Cell *)sp[0]=sp[1],sp+=2;	/* ! */
	ruleq();
	ZERO_Q();
	TO_RULES();
	dictq();
	ZERO_Q();
}
/* ==== Phrase maker ==== | >word... | 0 | */
struct
{
	Cell *i;
	Cell *r;
	Cell *e;
	Cell q[129];
}inputq_={&inputq_.q[128],&inputq_.q[128],&inputq_.q[128]};

void inputq()  /* -- q */  /* hold parsed input */
{
	*--sp=(Cell)&inputq_;
}

struct
{
	Cell *i;
	Cell *r;
	Cell *e;
	Cell q[129];
}outputq_={&outputq_.q[128],&outputq_.q[128],&outputq_.q[128]};

void outputq()  /* -- q */  /* hold matched phrase or parsed phrases */
{
	*--sp=(Cell)&outputq_;
}

void PHRASE()  /* terminator -- phrase */
{
	inputq();
	for(;;)	/* BEGIN */
	{
		--sp,sp[0]=sp[2];	/* OVER */
		CHAR();
		sp[1]^=sp[0],sp++;	/* XOR */
		if(!*sp++)break;	/* WHILE */
		GET_WORD();
		--sp,sp[0]=sp[2];	/* OVER */
		PUSH();
	}	/* REPEAT */
	INPUT();
	sp[0]+=1;	/* + */
	PLUS_IN();
	sp[1]=sp[0],sp++;	/* NIP */
	Q_QUERY();
	--sp,sp[0]=sp[1];	/* DUP */
	sp[0]+=1;	/* + */
	sp[0]*=sizeof(Cell);	/* CELLS */
	ALLOCATE();
	*--rp=sp[1],sp[1]=sp[0],sp[0]=*rp++;	/* SWAP */
	--sp,sp[0]=sp[1],sp[1]=sp[2];	/* NUP */
	for(*--rp=*sp++;*rp;(*rp)--)	/* FOR */
	{
		inputq();
		PULL();
		*--rp=sp[1],sp[1]=sp[0],sp[0]=*rp++;	/* SWAP */
		STORE_PLUS();
	}	/* NEXT */
	rp++;
	--sp,sp[0]=sp[1],sp[1]=0;	/* SWAP */
	*(Cell *)sp[0]=sp[1],sp+=2;	/* ! */
}

void PHRASES()  /* initiater \ terminater -- */
{
	for(;;)	/* BEGIN */
	{
		--sp,sp[0]=sp[1];	/* DUP */
		PHRASE();
		outputq();
		STUFF();
		--sp,sp[0]=sp[2];	/* OVER */
		INPUT();
		sp[0]=(Cell)(*(Byte *)sp[0]);	/* C@ */
		if(sp[1]==sp[0]) *++sp=-1; else *++sp=0;	/* = */
		if(!*sp++)break;	/* WHILE */
		INPUT();
		sp[0]+=1;	/* + */
		PLUS_IN();
	}	/* REPEAT */
	sp+=2;	/* 2DROP */
}

void STUFF_IT()  /* phrase -- */
{
	--sp,sp[0]=sp[1],sp[1]=0;	/* SWAP */
	for(;;)	/* BEGIN */
	{
		FETCH_PLUS();
		--sp,sp[0]=sp[2];	/* OVER */
		if(!*sp++)break;
	}	/* 0= UNTIL */
	sp+=2;	/* 2DROP */
	for(;;)	/* BEGIN */
	{
		QUESTION_DUP();
		if(!*sp++)break;	/* WHILE */
		inputq();
		STUFF();
	}	/* REPEAT */
}
/* ==== Method maker ==== | compiled words... EXIT | */

void METHOD()  /* -- method */
{
	*--sp=-1;	/* YES */
	activity();
	*(Cell *)sp[0]=sp[1],sp+=2;	/* ! */
	*--sp=(Cell)&_RIGHT_SQUARE_BRACKET.tick;	/* ' */
	tick=(void(**)())(*sp++), (**tick)();	/* EXECUTE */
	HERE();
	*--sp=(Cell)COLON_II;
	COMMA();
	for(;;)	/* BEGIN */
	{
		CHAR();
		sp[0]^=93;	/* XOR */
		if(!*sp++)break;	/* WHILE */
		BL();
		WORD();
		HERE();
		INTERPRET_WORD();
	}	/* REPEAT */
	CHAR();
	SKIP();
	*(char**)--sp="\004EXIT";
	INTERPRET_WORD();
	*--sp=(Cell)&_LEFT_SQUARE_BRACKET.tick;	/* ' */
	tick=(void(**)())(*sp++), (**tick)();	/* EXECUTE */
	*--sp=0;	/* NO */
	activity();
	*(Cell *)sp[0]=sp[1],sp+=2;	/* ! */
}

void IN_PHRASE()  /* terminator -- */
{
	*--rp=*sp++;	/* >R */
	*--sp=(Cell)&_AHEAD.tick;	/* ' */
	tick=(void(**)())(*sp++), (**tick)();	/* EXECUTE */
	*--sp=*rp++;	/* R> */
	PHRASE();
	*--rp=*sp++;	/* >R */
	*--sp=(Cell)&_ENDIF.tick;	/* ' */
	tick=(void(**)())(*sp++), (**tick)();	/* EXECUTE */
	*--sp=*rp++;	/* R> */
	*--sp=(Cell)&_LITERAL.tick;	/* ' */
	tick=(void(**)())(*sp++), (**tick)();	/* EXECUTE */
	*--sp=(Cell)&_STUFF_IT.tick;	/* ' */
	COMPILE();
}
/* ==== Rule maker ==== | >next rule | >phrase | >method | >substitute | */

void ADD_RULE()  /* sub \ meth \ phr -- */
{
	--sp,sp[0]=*(Cell*)sp[1];	/* DUP @ */
	if(*sp++)	/* IF */
	{
		--sp,sp[0]=*(Cell*)sp[1];	/* DUP @ */
	}
	else	/* ELSE */
	{
		_default();
	}
	--sp,sp[0]=sp[1];	/* DUP */
	ruleq();
	Q();
	FIND();
	if(!*sp++)
	{	/* 0= IF */
		--sp,sp[0]=sp[1];	/* DUP */
		ruleq();
		Q();
		INSERT();
	}
	ruleq();
	Q();
	ADJUNCT();
	*--sp=16;
	ALLOCATE();
	*--rp=sp[1],sp[1]=sp[0],sp[0]=*rp++;	/* SWAP */
	--sp,sp[0]=sp[1],sp[1]=sp[2];	/* NUP */
	LINK();
	sp[0]+=sizeof(Cell);	/* CELL + */
	STORE_PLUS();
	STORE_PLUS();
	*(Cell *)sp[0]=sp[1],sp+=2;	/* ! */
}

void ADD_RULES()  /* sub \ meth -- */
{
	outputq();
	Q_QUERY();
	for(*--rp=*sp++;*rp;(*rp)--)	/* FOR */
	{
		--sp,sp[0]=sp[2];	/* OVER */
		--sp,sp[0]=sp[2];	/* OVER */
		outputq();
		PULL();
		ADD_RULE();
	}	/* NEXT */
	rp++;
	sp+=2;	/* 2DROP */
}

void MAKE_RULES()  /* initiator \ terminator -- */
{
	--sp,sp[0]=sp[2];	/* OVER */
	--sp,sp[0]=sp[2];	/* OVER */
	PHRASES();
	INPUT();
	sp[0]=(Cell)(*(Byte *)sp[0]);	/* C@ */
	*--sp=91;
	if(sp[1]==sp[0]) *++sp=-1; else *++sp=0;	/* = */
	if(*sp++)	/* IF */
	{
		INPUT();
		sp[0]=(Cell)(*(Byte *)sp[0]);	/* C@ */
		SKIP();
		METHOD();
		*--rp=*sp++;	/* >R */
		--sp,sp[0]=sp[2];	/* OVER */
		INPUT();
		sp[0]=(Cell)(*(Byte *)sp[0]);	/* C@ */
		if(sp[1]==sp[0]) *++sp=-1; else *++sp=0;	/* = */
		if(*sp++)	/* IF */
		{
			*--rp=sp[1],sp[1]=sp[0],sp[0]=*rp++;	/* SWAP */
			SKIP();
			PHRASE();
		}
		else	/* ELSE */
		{
			sp+=2;	/* 2DROP */
			*--sp=0;
		}
		*--sp=*rp++;	/* R> */
	}
	else	/* ELSE */
	{
		sp+=2;	/* 2DROP */
		outputq();
		PULL();
		*--sp=0;
	}
	ADD_RULES();
}

void TIMBRE_LEFT_CURLEY_BRACKET()  /* -- */
{
	activity();
	if(*(Cell *)*sp++)
	{	/* @ IF */
		*--sp=125;
		IN_PHRASE();
	}
	else	/* ELSE */
	{
		compile();
		if(*(Cell *)*sp++)
		{	/* @ IF */
			*--sp=(Cell)&_LEFT_CURLEY_BRACKET.tick;	/* ' */
			tick=(void(**)())(*sp++), (**tick)();	/* EXECUTE */
		}
		else	/* ELSE */
		{
			*--sp=123;
			*--sp=125;
			MAKE_RULES();
		}
	}
}
/* ==== And for curly bracket rules ==== */

void VERTICAL_BAR()  /* -- */
{
	activity();
	if(*(Cell *)*sp++)
	{	/* @ IF */
		*--sp=124;
		IN_PHRASE();
	}
	else	/* ELSE */
	{
		*--sp=124;
		*--sp=124;
		MAKE_RULES();
	}
}
/* ==== Run time navigation ==== */
struct
{
	Cell name9;
}check_rule_={0,};

void check_rule()  /* -- a */  /* points to the rule which is being checked */
{
	*--sp=(Cell)&check_rule_;
}

struct
{
	Cell name11;
}check_word_={0,};

void check_word()  /* -- a */  /* points to a word in the phrase of the rule being checked */
{
	*--sp=(Cell)&check_word_;
}


void RULE_QUERY()  /* -- f */
{
	check_rule();
	sp[0]=*(Cell *)sp[0];	/* @ */
}

void RULE_DONE_QUERY()  /* -- f */
{
	check_word();
	sp[0]=*(Cell *)sp[0];	/* @ */
	sp[0]=*(Cell *)sp[0];	/* @ */
	sp[0]=sp[0]==0?-1:0;	/* 0= */
}

void FIRST_WORD()  /* -- */
{
	check_rule();
	sp[0]=*(Cell *)sp[0];	/* @ */
	sp[0]+=sizeof(Cell);	/* CELL + */
	sp[0]=*(Cell *)sp[0];	/* @ */
	check_word();
	*(Cell *)sp[0]=sp[1],sp+=2;	/* ! */
}

void NEXT_WORD()  /* -- */
{
	RULE_DONE_QUERY();
	if(!*sp++)
	{	/* 0= IF */
		*--sp=sizeof(Cell);	/* CELL */
		check_word();
		*(Cell *)sp[0]+=sp[1];
		sp+=2;	/* +! */
	}
	inputq();
	PULL();
	outputq();
	PUSH();
}

void NEXT_RULE()  /* -- */
{
	check_rule();
	sp[0]=*(Cell *)sp[0];	/* @ */
	sp[0]=*(Cell *)sp[0];	/* @ */
	--sp,sp[0]=sp[1];	/* DUP */
	check_rule();
	*(Cell *)sp[0]=sp[1],sp+=2;	/* ! */
	if(*sp++)	/* IF */
	{
		FIRST_WORD();
		NEXT_WORD();
	}
}

void SET_RULE()  /* s -- */
{
	ruleq();
	Q();
	ADJUNCT();
	sp[0]=*(Cell *)sp[0];	/* @ */
	check_rule();
	*(Cell *)sp[0]=sp[1],sp+=2;	/* ! */
	FIRST_WORD();
}

void FIND_RULE_QUERY()  /* -- f */
{
	inputq();
	Q();
	ruleq();
	Q();
	FIND();
	if(sp[0])
	{	/* DUP IF */
		--sp,sp[0]=sp[1];	/* DUP */
		SET_RULE();
	}
}
/* ==== Input parser ==== */

void GET_INPUT()  /* -- */
{
	inputq();
	Q_QUERY();
	if(*sp++)	/* IF */
	{
		return;	/* EXIT */
	}
	for(;;)	/* BEGIN */
	{
		CHAR();
		if(*sp++)	/* IF */
		{
			GET_WORD();
			inputq();
			PUSH();
			return;	/* EXIT */
		}
		INPUT_LINE();
		if(!*sp++)break;
	}	/* 0= UNTIL */
	SHELL_END();
}

void RESTORE_INPUT()  /* -- */
{
	outputq();
	inputq();
	--sp,sp[0]=sp[2];	/* OVER */
	Q_QUERY();
	for(*--rp=*sp++;*rp;(*rp)--)	/* FOR */
	{
		--sp,sp[0]=sp[2];	/* OVER */
		POP();
		--sp,sp[0]=sp[2];	/* OVER */
		STUFF();
	}	/* NEXT */
	rp++;
	sp+=2;	/* 2DROP */
}

void WORD_MATCH_QUERY()  /* -- f */
{
	check_word();
	sp[0]=*(Cell *)sp[0];	/* @ */
	sp[0]=*(Cell *)sp[0];	/* @ */
	inputq();
	Q();
	--sp,sp[0]=sp[2];	/* OVER */
	--sp,sp[0]=sp[2];	/* OVER */
	if(sp[1]==sp[0]) *++sp=-1; else *++sp=0;	/* = */
	if(*sp++)	/* IF */
	{
		sp+=2;	/* 2DROP */
		*--sp=-1;	/* YES */
	}
	else	/* ELSE */
	{
		COMPARE();
	}
}
/* ==== Rule execution ==== */
struct
{
	Cell name13;
}rule_echo_={0,};

void rule_echo()  /* -- a */  /* echo rules when executing */
{
	*--sp=(Cell)&rule_echo_;
}


void DO_METHOD()  /* rule -- */
{
	sp[0]+=8;	/* + */
	sp[0]=*(Cell *)sp[0];	/* @ */
	QUESTION_DUP();
	if(*sp++)	/* IF */
	{
		tick=(void(**)())(*sp++), (**tick)();	/* EXECUTE */
	}
}

void SUBSTITUTE()  /* rule -- */
{
	sp[0]+=12;	/* + */
	sp[0]=*(Cell *)sp[0];	/* @ */
	QUESTION_DUP();
	if(!*sp++)
	{	/* 0= IF */
		return;	/* EXIT */
	}
	--sp,sp[0]=sp[1],sp[1]=0;	/* SWAP */
	for(;;)	/* BEGIN */
	{
		FETCH_PLUS();
		--sp,sp[0]=sp[2];	/* OVER */
		if(!*sp++)break;
	}	/* 0= UNTIL */
	sp+=2;	/* 2DROP */
	for(;;)	/* BEGIN */
	{
		QUESTION_DUP();
		if(!*sp++)break;	/* WHILE */
		inputq();
		STUFF();
	}	/* REPEAT */
}

void RUN_WORD()  /* s -- */
{
	latest();
	SEARCH_DICTIONARY();
	if(*sp++)	/* IF */
	{
		L_TO_TICK();
		tick=(void(**)())(*sp++), (**tick)();	/* EXECUTE */
		return;	/* EXIT */
	}
	QUESTION_CR();
	COUNT();
	TYPE();
	*(char**)--sp="\060 can't be found in the dictionary and isn't run.";
	COUNT();
	TYPE();
}

void RUN_RULE()  /* rule -- */
{
	*--rp=*sp++;	/* >R */
	rule_echo();
	if(*(Cell *)*sp++)
	{	/* @ IF */
		*--sp=*rp;	/* R */
		sp[0]+=sizeof(Cell);	/* CELL + */
		*(char**)--sp="\005.RULE";
		RUN_WORD();
	}
	*--sp=*rp;	/* R */
	DO_METHOD();
	*--sp=*rp++;	/* R> */
	SUBSTITUTE();
}
/* ==== Rule cache ==== */
struct
{
	Cell name15;
}rule_={0,};

void rule()  /* -- a */  /* address of rule which is in the cache */
{
	*--sp=(Cell)&rule_;
}

struct
{
	Cell name17;
}rule_size_={0,};

void rule_size()  /* -- a */  /* length of phrase in cached rule */
{
	*--sp=(Cell)&rule_size_;
}


void CACHED_QUERY()  /* -- f */
{
	rule_size();
	sp[0]=*(Cell *)sp[0];	/* @ */
}

void CACHE_RULE()  /* -- */
{
	outputq();
	Q_QUERY();
	rule_size();
	*(Cell *)sp[0]=sp[1],sp+=2;	/* ! */
	check_rule();
	sp[0]=*(Cell *)sp[0];	/* @ */
	rule();
	*(Cell *)sp[0]=sp[1],sp+=2;	/* ! */
}

void TURF_PHRASE()  /* -- */
{
	rule_size();
	sp[0]=*(Cell *)sp[0];	/* @ */
	for(*--rp=*sp++;*rp;(*rp)--)	/* FOR */
	{
		inputq();
		PULL();
		sp++;	/* DROP */
	}	/* NEXT */
	rp++;
}

void RUN_CACHE()  /* -- */
{
	TURF_PHRASE();
	rule();
	sp[0]=*(Cell *)sp[0];	/* @ */
	RUN_RULE();
	*--sp=0;
	rule_size();
	*(Cell *)sp[0]=sp[1],sp+=2;	/* ! */
	*--sp=0;
	check_rule();
	*(Cell *)sp[0]=sp[1],sp+=2;	/* ! */
}

void LONGER_QUERY()  /* -- f */
{
	outputq();
	Q_QUERY();
	rule_size();
	sp[0]=*(Cell *)sp[0];	/* @ */
	if(sp[1]>sp[0]) *++sp=-1; else *++sp=0;	/* U> */
}
/* ==== Timbre engine ==== */

void QUESTION_DEFAULT()  /* -- */
{
	for(;;)	/* BEGIN */
	{
		RULE_SETS_QUERY();
		if(!*sp++)break;	/* WHILE */
		_default();
		ruleq();
		Q();
		FIND();
		if(*sp++)	/* IF */
		{
			_default();
			ruleq();
			Q();
			ADJUNCT();
			sp[0]=*(Cell *)sp[0];	/* @ */
			RUN_RULE();
			RESET_RULES();
			return;	/* EXIT */
		}
		NEXT_RULE_SET();
	}	/* REPEAT */
	RESET_RULES();
	*(char**)--sp="\026No rules match input. ";
	COUNT();
	TYPE();
	ABORT();
}

void CHECK_RULE()  /* -- */
{
	GET_INPUT();
	WORD_MATCH_QUERY();
	if(*sp++)	/* IF */
	{
		NEXT_WORD();
	}
	else	/* ELSE */
	{
		RESTORE_INPUT();
		NEXT_RULE();
	}
}

void CHECK_RULES()  /* -- */
{
	for(;;)	/* BEGIN */
	{
		RULE_DONE_QUERY();
		if(*sp++)	/* IF */
		{
			LONGER_QUERY();
			if(*sp++)	/* IF */
			{
				CACHE_RULE();
			}
			RESTORE_INPUT();
			NEXT_RULE();
		}
		else	/* ELSE */
		{
			CHECK_RULE();
		}
		RULE_QUERY();
		if(!*sp++)break;
	}	/* 0= UNTIL */
	RULE_SETS_QUERY();
	if(*sp++)	/* IF */
	{
		NEXT_RULE_SET();
	}
}

void CHECK_RULE_SETS()  /* -- */
{
	RULE_SETS_QUERY();
	if(*sp++)	/* IF */
	{
		GET_INPUT();
		FIND_RULE_QUERY();
		if(*sp++)	/* IF */
		{
			NEXT_WORD();
		}
		else	/* ELSE */
		{
			NEXT_RULE_SET();
		}
	}
	else	/* ELSE */
	{
		RESET_RULES();
		CACHED_QUERY();
		if(*sp++)	/* IF */
		{
			RUN_CACHE();
		}
		else	/* ELSE */
		{
			QUESTION_DEFAULT();
		}
	}
}

void TRANSLATE_FILE()  /* -- */
{
	shell_nest();
	if(setjmp(*ep)==0)
	{
		for(;;)	/* BEGIN */
		{
			RULE_QUERY();
			if(*sp++)	/* IF */
			{
				CHECK_RULES();
			}
			else	/* ELSE */
			{
				CHECK_RULE_SETS();
			}
		}	/* REPEAT */
	}
	shell_unest();
	if(!*sp++)
	{	/* 0= IF */
		SHELL_END();
	}
}

void TRANSLATE()  /* -- */  /* for running Timbre without affecting open files */
{
	PUSH_FILE();
	*--sp=0;
	file();
	*(Cell *)sp[0]=sp[1],sp+=2;	/* ! */
	TRANSLATE_FILE();
	POP_FILE();
}
/* ==== File interface ==== */

void TRANSLATOR_INIT()  /* -- */
{
	inputq();
	ZERO_Q();
	outputq();
	ZERO_Q();
	dictq();
	ZERO_Q();
	*--sp=0;
	check_rule();
	*(Cell *)sp[0]=sp[1],sp+=2;	/* ! */
}

void TLD()  /* "file" | s -- */
{  /* translate a file */
	BL();
	WORD();
	HERE();
	if(*(Byte *)*sp++)
	{	/* C@ IF */
		HERE();
	}
	OPEN();
	QUESTION_FILE();
	*--sp=(Cell)&_TRANSLATOR_INIT.tick;	/* ' */
	LATE();
	tick=(void(**)())(*sp++), (**tick)();	/* EXECUTE */
	shell_nest();
	if(setjmp(*ep)==0)
	{
		TRANSLATE_FILE();
	}
	shell_unest();
	CLOSE();
	if(!*sp++)
	{	/* 0= IF */
		ABORT();
	}
}
/* Rules Tools */
/* ==== Rule printer ==== */

void GET_PHRASE()  /* -- a */
{
	rule();
	sp[0]=*(Cell *)sp[0];	/* @ */
	sp[0]+=sizeof(Cell);	/* CELL + */
	sp[0]=*(Cell *)sp[0];	/* @ */
}

void DOT_PHRASE()  /* a -- */
{
	for(;;)	/* BEGIN */
	{
		FETCH_PLUS();
		*--rp=sp[1],sp[1]=sp[0],sp[0]=*rp++;	/* SWAP */
		QUESTION_DUP();
		if(!*sp++)break;	/* WHILE */
		COUNT();
		TYPE();
		SPACE();
	}	/* REPEAT */
	sp++;	/* DROP */
}

void DOT_LEFT_CURLEY_BRACKET_PHRASE_RIGHT_CURLEY_BRACKET()  /* a -- */
{
	*(char**)--sp="\002{ ";
	COUNT();
	TYPE();
	DOT_PHRASE();
	*(char**)--sp="\001}";
	COUNT();
	TYPE();
	FLUSH_EMITS();
}

void DOT_METHOD()  /* a -- */
{
	QUESTION_DUP();
	if(*sp++)	/* IF */
	{
		sp[0]+=sizeof(Cell);	/* CELL + */
		*(char**)--sp="\002[ ";
		COUNT();
		TYPE();
		*(char**)--sp="\003SEE";
		latest();
		SEARCH_DICTIONARY();
		if(*sp++)	/* IF */
		{
			L_TO_TICK();
			tick=(void(**)())(*sp++), (**tick)();	/* EXECUTE */
		}
		else	/* ELSE */
		{
			sp+=2;	/* 2DROP */
		}
		*(char**)--sp="\001]";
		COUNT();
		TYPE();
	}
}

void DOT_SUBSTITUTE()  /* a -- */
{
	QUESTION_DUP();
	if(*sp++)	/* IF */
	{
		DOT_LEFT_CURLEY_BRACKET_PHRASE_RIGHT_CURLEY_BRACKET();
	}
}

void DOT_RULE()  /* rule -- */
{
	QUESTION_CR();
	FETCH_PLUS();
	*--rp=sp[1],sp[1]=sp[0],sp[0]=*rp++;	/* SWAP */
	DOT_LEFT_CURLEY_BRACKET_PHRASE_RIGHT_CURLEY_BRACKET();
	FETCH_PLUS();
	*--rp=sp[1],sp[1]=sp[0],sp[0]=*rp++;	/* SWAP */
	DOT_METHOD();
	sp[0]=*(Cell *)sp[0];	/* @ */
	DOT_SUBSTITUTE();
	FLUSH_EMITS();
	QUESTION_STOP();
}

void DOTRULES()  /* -- */
{
	check_rule();
	sp[0]=*(Cell *)sp[0];	/* @ */
	for(;;)	/* BEGIN */
	{
		QUESTION_DUP();
		if(!*sp++)break;	/* WHILE */
		FETCH_PLUS();
		DOT_RULE();
	}	/* REPEAT */
}

void RULE()  /* -- */
{
	inputq();
	ZERO_Q();
	GET_INPUT();
	ZERO_TIB();
	if(*sp++)	/* IF */
	{
		FIND_RULE_QUERY();
		if(*sp++)	/* IF */
		{
			DOTRULES();
		}
		else	/* ELSE */
		{
			*(char**)--sp="\010no rule.";
			COUNT();
			TYPE();
		}
	}
}
/* ==== Q printer ==== */

void DOT_Q()  /* q -- */
{
	--sp,sp[0]=sp[1];	/* DUP */
	Q_QUERY();
	for(*--rp=*sp++;*rp;(*rp)--)	/* FOR */
	{
		--sp,sp[0]=sp[1];	/* DUP */
		Q_FROM();
		--sp,sp[0]=sp[1];	/* DUP */
		COUNT();
		TYPE();
		SPACE();
		--sp,sp[0]=sp[2];	/* OVER */
		TO_Q();
	}	/* NEXT */
	rp++;
	sp++;	/* DROP */
}

void DOT_QS()  /* -- */
{
	QUESTION_CR();
	FLUSH_EMITS();
	QUESTION_STOP();
	*(char**)--sp="\010inputq: ";
	COUNT();
	TYPE();
	inputq();
	DOT_Q();
	*(char**)--sp="\012 outputq: ";
	COUNT();
	TYPE();
	outputq();
	DOT_Q();
}
/* ==== Rule display ==== */

void DOT_REPORT()  /* n \ n \ n \ n -- */
{
	sp[1]-=sp[0],sp++;	/* - */
	QUESTION_DUP();
	if(*sp++)	/* IF */
	{
		--sp,sp[0]=sp[1];	/* DUP */
		sp[0]=-(sp[0]);	/* NEGATE */
		ALLOT();
		*(char**)--sp="\023Dictionary grew by ";
		COUNT();
		TYPE();
		DOT_D();
		*(char**)--sp="\010bytes.  ";
		COUNT();
		TYPE();
	}
	sp[1]-=sp[0],sp++;	/* - */
	QUESTION_DUP();
	if(*sp++)	/* IF */
	{
		DOT_S();
		sp=sp0_;	/* SP! */
	}
	*--sp=(Cell)&_LEFT_SQUARE_BRACKET.tick;	/* ' */
	tick=(void(**)())(*sp++), (**tick)();	/* EXECUTE */
}

void SHOWME()  /* -- */
{
	QUESTION_CR();
	TRANSLATOR_INIT();
	HERE();
	*--rp=*sp++;	/* >R */
	*--rp=sp0_-sp;
	*--sp=*rp++;	/* DEPTH */
	*--rp=*sp++;	/* >R */
	*--sp=-1;	/* YES */
	rule_echo();
	*(Cell *)sp[0]=sp[1],sp+=2;	/* ! */
	shell_nest();
	if(setjmp(*ep)==0)
	{
		TRANSLATE();
	}
	shell_unest();
	sp++;	/* DROP */
	*--rp=sp0_-sp;
	*--sp=*rp++;	/* DEPTH */
	*--sp=*rp++;	/* R> */
	HERE();
	*--sp=*rp++;	/* R> */
	DOT_REPORT();
	ZERO_TIB();
	*--sp=0;	/* NO */
	rule_echo();
	*(Cell *)sp[0]=sp[1],sp+=2;	/* ! */
}
/* ==== Dump a rule ==== */

void DOTRULE()  /* rule -- */
{
	if(sp[0]==0)
	{	/* DUP 0= IF */
		sp++;	/* DROP */
		*(char**)--sp="\010No rule.";
		COUNT();
		TYPE();
		return;	/* EXIT */
	}
	QUESTION_CR();
	*(char**)--sp="\013Next rule: ";
	COUNT();
	TYPE();
	FETCH_PLUS();
	*--rp=sp[1],sp[1]=sp[0],sp[0]=*rp++;	/* SWAP */
	DOT();
	_CR();
	*(char**)--sp="\007Phrase:";
	COUNT();
	TYPE();
	FETCH_PLUS();
	*--rp=sp[1],sp[1]=sp[0],sp[0]=*rp++;	/* SWAP */
	--sp,sp[0]=sp[1];	/* DUP */
	DOT_H();
	DOT_PHRASE();
	_CR();
	*(char**)--sp="\007Method:";
	COUNT();
	TYPE();
	FETCH_PLUS();
	*--rp=sp[1],sp[1]=sp[0],sp[0]=*rp++;	/* SWAP */
	QUESTION_DUP();
	if(*sp++)	/* IF */
	{
		--sp,sp[0]=sp[1];	/* DUP */
		DOT_H();  /* #IFDEF DECODE_TILL_EXIT  DECODE_TILL_EXIT  #ELSE  DROP  #ENDIF*/
		sp++;	/* DROP */
	}
	else	/* ELSE */
	{
		*(char**)--sp="\005 not!";
		COUNT();
		TYPE();
	}
	_CR();
	*(char**)--sp="\013Substitute:";
	COUNT();
	TYPE();
	sp[0]=*(Cell *)sp[0];	/* @ */
	QUESTION_DUP();
	if(*sp++)	/* IF */
	{
		--sp,sp[0]=sp[1];	/* DUP */
		DOT_H();
		DOT_PHRASE();
	}
	else	/* ELSE */
	{
		*(char**)--sp="\005 not!";
		COUNT();
		TYPE();
	}
}

void DOT_LAST_RULE()  /* -- */
{
	QUESTION_CR();
	*(char**)--sp="\014cache-size: ";
	COUNT();
	TYPE();
	rule_size();
	sp[0]=*(Cell *)sp[0];	/* @ */
	DOT();
	rule();
	sp[0]=*(Cell *)sp[0];	/* @ */
	QUESTION_DUP();
	if(*sp++)	/* IF */
	{
		sp[0]+=sizeof(Cell);	/* CELL + */
		DOT_RULE();
	}
	_CR();
	*(char**)--sp="\006rule: ";
	COUNT();
	TYPE();
	check_rule();
	sp[0]=*(Cell *)sp[0];	/* @ */
	QUESTION_DUP();
	if(*sp++)	/* IF */
	{
		sp[0]+=sizeof(Cell);	/* CELL + */
		DOT_RULE();
	}
}
/* ==== Timber status ==== */

void DOT_TIMBRE()  /* -- */
{
	QUESTION_CR();
	ruleq();
	Q_QUERY();
	DOT();
	*(char**)--sp="\026unchecked rule sets.  ";
	COUNT();
	TYPE();
	dictq();
	Q_QUERY();
	DOT();
	*(char**)--sp="\024checked rule sets.  ";
	COUNT();
	TYPE();
	DOT_QS();
	DOT_LAST_RULE();
	RULE_QUERY();
	if(*sp++)	/* IF */
	{
		RULE_DONE_QUERY();
		if(*sp++)	/* IF */
		{
			*(char**)--sp="\021current RULE done";
			COUNT();
			TYPE();
		}
	}
}
/* ==== Print phrase in outputq ==== */

void QUESTION_RMARGIN()  /* n -- n */
{
	--sp,sp[0]=sp[1];	/* DUP */
	sp[0]+=2;	/* + */
	*--sp=77;
	if((Integer)sp[1]>(Integer)sp[0]) *++sp=-1; else *++sp=0;	/* > */
	if(*sp++)	/* IF */
	{
		_CR();
	}
}

void D_TO_TABLE()  /* dict -- string table \ capacity */
{
	FETCH_PLUS();
	sp[0]=*(Cell *)sp[0];	/* @ */
}

void D_TO_ADJUNCT()  /* dict -- adjunct table \ capacity */
{
	sp[0]+=sizeof(Cell);	/* CELL + */
	FETCH_PLUS();
	sp[0]+=sizeof(Cell);	/* CELL + */
	sp[0]=*(Cell *)sp[0];	/* @ */
	*--rp=sp[1],sp[1]=sp[0],sp[0]=*rp++;	/* SWAP */
}

void DOT_DICT()  /* dictionary -- */
{
	D_TO_TABLE();
	for(*--rp=*sp++;*rp;(*rp)--)	/* FOR */
	{
		FETCH_PLUS();
		*--rp=sp[1],sp[1]=sp[0],sp[0]=*rp++;	/* SWAP */
		QUESTION_DUP();
		if(*sp++)	/* IF */
		{
			COUNT();
			QUESTION_RMARGIN();
			TYPE();
			SPACE();
		}
	}	/* NEXT */
	rp++;
	sp++;	/* DROP */
}

void DOT_WORDS()  /* -- */
{
	rule_words();
	sp[0]=*(Cell *)sp[0];	/* @ */
	DOT_DICT();
}

void DOT_RULES()  /* -- */
{
	ruleq();
	Q();
	--sp,sp[0]=sp[1];	/* DUP */
	DOT_DICT();
	D_TO_ADJUNCT();
	for(*--rp=*sp++;*rp;(*rp)--)	/* FOR */
	{
		FETCH_PLUS();
		*--rp=sp[1],sp[1]=sp[0],sp[0]=*rp++;	/* SWAP */
		QUESTION_DUP();
		if(*sp++)	/* IF */
		{
			check_rule();
			*(Cell *)sp[0]=sp[1],sp+=2;	/* ! */
			DOTRULES();
		}
	}	/* NEXT */
	rp++;
	sp++;	/* DROP */
}
